package com.muyu.system.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.muyu.system.domain.SysNotice;
import com.muyu.system.domain.req.NoticeListReq;
import com.muyu.system.domain.resp.NoticeRes;
import com.muyu.system.domain.vo.NoticeVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 通知公告表 数据层
 *
 * @author muyu
 */
public interface SysNoticeMapper extends BaseMapper<SysNotice> {
    /**
     * 查询公告信息
     *
     * @param noticeId 公告ID
     *
     * @return 公告信息
     */
    public SysNotice selectNoticeById (Long noticeId);

    /**
     * 查询公告列表
     *
     * @param notice 公告信息
     *
     * @return 公告集合
     */
    public List<SysNotice> selectNoticeList (SysNotice notice);

    /**
     * 新增公告
     *
     * @param notice 公告信息
     *
     * @return 结果
     */
    public int insertNotice (NoticeVo notice);

    /**
     * 修改公告
     *
     * @param notice 公告信息
     *
     * @return 结果
     */
    public int updateNotice (SysNotice notice);

    /**
     * 批量删除公告
     *
     * @param noticeId 公告ID
     *
     * @return 结果
     */
    public int deleteNoticeById (Long noticeId);

    /**
     * 批量删除公告信息
     *
     * @param noticeIds 需要删除的公告ID
     *
     * @return 结果
     */
    public int deleteNoticeByIds (Long[] noticeIds);

    void insertInformUserId(@Param("noticeId") Long noticeId, @Param("userIds") List<Integer> userIds);


    void insertInformDept(@Param("noticeId") Long noticeId, @Param("deptIds") List<Long> deptIds);

    List<NoticeRes> findList(NoticeListReq req);

    NoticeRes look(Integer id);

    void updNoticeState(Integer id);

    int addNoticesUserIdAndNoticeId(@Param("userId") Long userId, @Param("sysNotices") List<SysNotice> sysNotices);

    int NoticeCount(Integer id);

    int NoticePageview(Integer id);
}
